/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_STREAM)

#include "JSMediaTrackSupportedConstraints.h"

#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertOptional.h"
#include "JSDOMGlobalObject.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

#if ENABLE(MEDIA_STREAM)

template<> ConversionResult<IDLDictionary<MediaTrackSupportedConstraints>> convertDictionary<MediaTrackSupportedConstraints>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    MediaTrackSupportedConstraints result;
    JSValue aspectRatioValue;
    if (isNullOrUndefined)
        aspectRatioValue = jsUndefined();
    else {
        aspectRatioValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "aspectRatio"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto aspectRatioConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, aspectRatioValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(aspectRatioConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.aspectRatio = aspectRatioConversionResult.releaseReturnValue();
    JSValue backgroundBlurValue;
    if (isNullOrUndefined)
        backgroundBlurValue = jsUndefined();
    else {
        backgroundBlurValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "backgroundBlur"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto backgroundBlurConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, backgroundBlurValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(backgroundBlurConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.backgroundBlur = backgroundBlurConversionResult.releaseReturnValue();
    JSValue deviceIdValue;
    if (isNullOrUndefined)
        deviceIdValue = jsUndefined();
    else {
        deviceIdValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "deviceId"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto deviceIdConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, deviceIdValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(deviceIdConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.deviceId = deviceIdConversionResult.releaseReturnValue();
    JSValue displaySurfaceValue;
    if (isNullOrUndefined)
        displaySurfaceValue = jsUndefined();
    else {
        displaySurfaceValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "displaySurface"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto displaySurfaceConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, displaySurfaceValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(displaySurfaceConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.displaySurface = displaySurfaceConversionResult.releaseReturnValue();
    JSValue echoCancellationValue;
    if (isNullOrUndefined)
        echoCancellationValue = jsUndefined();
    else {
        echoCancellationValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "echoCancellation"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto echoCancellationConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, echoCancellationValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(echoCancellationConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.echoCancellation = echoCancellationConversionResult.releaseReturnValue();
    JSValue facingModeValue;
    if (isNullOrUndefined)
        facingModeValue = jsUndefined();
    else {
        facingModeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "facingMode"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto facingModeConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, facingModeValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(facingModeConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.facingMode = facingModeConversionResult.releaseReturnValue();
    JSValue frameRateValue;
    if (isNullOrUndefined)
        frameRateValue = jsUndefined();
    else {
        frameRateValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "frameRate"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto frameRateConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, frameRateValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(frameRateConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.frameRate = frameRateConversionResult.releaseReturnValue();
    JSValue groupIdValue;
    if (isNullOrUndefined)
        groupIdValue = jsUndefined();
    else {
        groupIdValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "groupId"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto groupIdConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, groupIdValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(groupIdConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.groupId = groupIdConversionResult.releaseReturnValue();
    JSValue heightValue;
    if (isNullOrUndefined)
        heightValue = jsUndefined();
    else {
        heightValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "height"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto heightConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, heightValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(heightConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.height = heightConversionResult.releaseReturnValue();
    JSValue sampleRateValue;
    if (isNullOrUndefined)
        sampleRateValue = jsUndefined();
    else {
        sampleRateValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "sampleRate"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto sampleRateConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, sampleRateValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(sampleRateConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.sampleRate = sampleRateConversionResult.releaseReturnValue();
    JSValue sampleSizeValue;
    if (isNullOrUndefined)
        sampleSizeValue = jsUndefined();
    else {
        sampleSizeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "sampleSize"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto sampleSizeConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, sampleSizeValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(sampleSizeConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.sampleSize = sampleSizeConversionResult.releaseReturnValue();
    JSValue torchValue;
    if (isNullOrUndefined)
        torchValue = jsUndefined();
    else {
        torchValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "torch"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto torchConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, torchValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(torchConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.torch = torchConversionResult.releaseReturnValue();
    JSValue volumeValue;
    if (isNullOrUndefined)
        volumeValue = jsUndefined();
    else {
        volumeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "volume"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto volumeConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, volumeValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(volumeConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.volume = volumeConversionResult.releaseReturnValue();
    JSValue whiteBalanceModeValue;
    if (isNullOrUndefined)
        whiteBalanceModeValue = jsUndefined();
    else {
        whiteBalanceModeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "whiteBalanceMode"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto whiteBalanceModeConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, whiteBalanceModeValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(whiteBalanceModeConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.whiteBalanceMode = whiteBalanceModeConversionResult.releaseReturnValue();
    JSValue widthValue;
    if (isNullOrUndefined)
        widthValue = jsUndefined();
    else {
        widthValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "width"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto widthConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, widthValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(widthConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.width = widthConversionResult.releaseReturnValue();
    JSValue zoomValue;
    if (isNullOrUndefined)
        zoomValue = jsUndefined();
    else {
        zoomValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "zoom"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto zoomConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, zoomValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { true }; });
    if (UNLIKELY(zoomConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.zoom = zoomConversionResult.releaseReturnValue();
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::JSGlobalObject& lexicalGlobalObject, JSDOMGlobalObject& globalObject, const MediaTrackSupportedConstraints& dictionary)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);

    auto result = constructEmptyObject(&lexicalGlobalObject, globalObject.objectPrototype());

    auto aspectRatioValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.aspectRatio);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "aspectRatio"_s), aspectRatioValue);
    auto backgroundBlurValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.backgroundBlur);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "backgroundBlur"_s), backgroundBlurValue);
    auto deviceIdValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.deviceId);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "deviceId"_s), deviceIdValue);
    auto displaySurfaceValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.displaySurface);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "displaySurface"_s), displaySurfaceValue);
    auto echoCancellationValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.echoCancellation);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "echoCancellation"_s), echoCancellationValue);
    auto facingModeValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.facingMode);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "facingMode"_s), facingModeValue);
    auto frameRateValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.frameRate);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "frameRate"_s), frameRateValue);
    auto groupIdValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.groupId);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "groupId"_s), groupIdValue);
    auto heightValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.height);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "height"_s), heightValue);
    auto sampleRateValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.sampleRate);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "sampleRate"_s), sampleRateValue);
    auto sampleSizeValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.sampleSize);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "sampleSize"_s), sampleSizeValue);
    auto torchValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.torch);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "torch"_s), torchValue);
    auto volumeValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.volume);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "volume"_s), volumeValue);
    auto whiteBalanceModeValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.whiteBalanceMode);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "whiteBalanceMode"_s), whiteBalanceModeValue);
    auto widthValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.width);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "width"_s), widthValue);
    auto zoomValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.zoom);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "zoom"_s), zoomValue);
    return result;
}

#endif

} // namespace WebCore

#endif // ENABLE(MEDIA_STREAM)
