/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(VIDEO)

#include "JSVideoFrameMetadata.h"

#include "JSDOMConvertNumbers.h"
#include "JSDOMGlobalObject.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

#if ENABLE(VIDEO)

template<> ConversionResult<IDLDictionary<VideoFrameMetadata>> convertDictionary<VideoFrameMetadata>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    VideoFrameMetadata result;
    JSValue captureTimeValue;
    if (isNullOrUndefined)
        captureTimeValue = jsUndefined();
    else {
        captureTimeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "captureTime"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (!captureTimeValue.isUndefined()) {
        auto captureTimeConversionResult = convert<IDLDouble>(lexicalGlobalObject, captureTimeValue);
        if (UNLIKELY(captureTimeConversionResult.hasException(throwScope)))
            return ConversionResultException { };
        result.captureTime = captureTimeConversionResult.releaseReturnValue();
    }
    JSValue expectedDisplayTimeValue;
    if (isNullOrUndefined)
        expectedDisplayTimeValue = jsUndefined();
    else {
        expectedDisplayTimeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "expectedDisplayTime"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (expectedDisplayTimeValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "expectedDisplayTime"_s, "VideoFrameMetadata"_s, "double"_s);
        return ConversionResultException { };
    }
    auto expectedDisplayTimeConversionResult = convert<IDLDouble>(lexicalGlobalObject, expectedDisplayTimeValue);
    if (UNLIKELY(expectedDisplayTimeConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.expectedDisplayTime = expectedDisplayTimeConversionResult.releaseReturnValue();
    JSValue heightValue;
    if (isNullOrUndefined)
        heightValue = jsUndefined();
    else {
        heightValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "height"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (heightValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "height"_s, "VideoFrameMetadata"_s, "unsigned long"_s);
        return ConversionResultException { };
    }
    auto heightConversionResult = convert<IDLUnsignedLong>(lexicalGlobalObject, heightValue);
    if (UNLIKELY(heightConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.height = heightConversionResult.releaseReturnValue();
    JSValue mediaTimeValue;
    if (isNullOrUndefined)
        mediaTimeValue = jsUndefined();
    else {
        mediaTimeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "mediaTime"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (mediaTimeValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "mediaTime"_s, "VideoFrameMetadata"_s, "double"_s);
        return ConversionResultException { };
    }
    auto mediaTimeConversionResult = convert<IDLDouble>(lexicalGlobalObject, mediaTimeValue);
    if (UNLIKELY(mediaTimeConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.mediaTime = mediaTimeConversionResult.releaseReturnValue();
    JSValue presentationTimeValue;
    if (isNullOrUndefined)
        presentationTimeValue = jsUndefined();
    else {
        presentationTimeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "presentationTime"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (presentationTimeValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "presentationTime"_s, "VideoFrameMetadata"_s, "double"_s);
        return ConversionResultException { };
    }
    auto presentationTimeConversionResult = convert<IDLDouble>(lexicalGlobalObject, presentationTimeValue);
    if (UNLIKELY(presentationTimeConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.presentationTime = presentationTimeConversionResult.releaseReturnValue();
    JSValue presentedFramesValue;
    if (isNullOrUndefined)
        presentedFramesValue = jsUndefined();
    else {
        presentedFramesValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "presentedFrames"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (presentedFramesValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "presentedFrames"_s, "VideoFrameMetadata"_s, "unsigned long"_s);
        return ConversionResultException { };
    }
    auto presentedFramesConversionResult = convert<IDLUnsignedLong>(lexicalGlobalObject, presentedFramesValue);
    if (UNLIKELY(presentedFramesConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.presentedFrames = presentedFramesConversionResult.releaseReturnValue();
    JSValue processingDurationValue;
    if (isNullOrUndefined)
        processingDurationValue = jsUndefined();
    else {
        processingDurationValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "processingDuration"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (!processingDurationValue.isUndefined()) {
        auto processingDurationConversionResult = convert<IDLDouble>(lexicalGlobalObject, processingDurationValue);
        if (UNLIKELY(processingDurationConversionResult.hasException(throwScope)))
            return ConversionResultException { };
        result.processingDuration = processingDurationConversionResult.releaseReturnValue();
    }
    JSValue receiveTimeValue;
    if (isNullOrUndefined)
        receiveTimeValue = jsUndefined();
    else {
        receiveTimeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "receiveTime"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (!receiveTimeValue.isUndefined()) {
        auto receiveTimeConversionResult = convert<IDLDouble>(lexicalGlobalObject, receiveTimeValue);
        if (UNLIKELY(receiveTimeConversionResult.hasException(throwScope)))
            return ConversionResultException { };
        result.receiveTime = receiveTimeConversionResult.releaseReturnValue();
    }
    JSValue rtpTimestampValue;
    if (isNullOrUndefined)
        rtpTimestampValue = jsUndefined();
    else {
        rtpTimestampValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "rtpTimestamp"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (!rtpTimestampValue.isUndefined()) {
        auto rtpTimestampConversionResult = convert<IDLUnsignedLong>(lexicalGlobalObject, rtpTimestampValue);
        if (UNLIKELY(rtpTimestampConversionResult.hasException(throwScope)))
            return ConversionResultException { };
        result.rtpTimestamp = rtpTimestampConversionResult.releaseReturnValue();
    }
    JSValue widthValue;
    if (isNullOrUndefined)
        widthValue = jsUndefined();
    else {
        widthValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "width"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (widthValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "width"_s, "VideoFrameMetadata"_s, "unsigned long"_s);
        return ConversionResultException { };
    }
    auto widthConversionResult = convert<IDLUnsignedLong>(lexicalGlobalObject, widthValue);
    if (UNLIKELY(widthConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.width = widthConversionResult.releaseReturnValue();
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::JSGlobalObject& lexicalGlobalObject, JSDOMGlobalObject& globalObject, const VideoFrameMetadata& dictionary)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);

    auto result = constructEmptyObject(&lexicalGlobalObject, globalObject.objectPrototype());

    if (!IDLDouble::isNullValue(dictionary.captureTime)) {
        auto captureTimeValue = toJS<IDLDouble>(lexicalGlobalObject, throwScope, IDLDouble::extractValueFromNullable(dictionary.captureTime));
        RETURN_IF_EXCEPTION(throwScope, { });
        result->putDirect(vm, JSC::Identifier::fromString(vm, "captureTime"_s), captureTimeValue);
    }
    auto expectedDisplayTimeValue = toJS<IDLDouble>(lexicalGlobalObject, throwScope, dictionary.expectedDisplayTime);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "expectedDisplayTime"_s), expectedDisplayTimeValue);
    auto heightValue = toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, dictionary.height);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "height"_s), heightValue);
    auto mediaTimeValue = toJS<IDLDouble>(lexicalGlobalObject, throwScope, dictionary.mediaTime);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "mediaTime"_s), mediaTimeValue);
    auto presentationTimeValue = toJS<IDLDouble>(lexicalGlobalObject, throwScope, dictionary.presentationTime);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "presentationTime"_s), presentationTimeValue);
    auto presentedFramesValue = toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, dictionary.presentedFrames);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "presentedFrames"_s), presentedFramesValue);
    if (!IDLDouble::isNullValue(dictionary.processingDuration)) {
        auto processingDurationValue = toJS<IDLDouble>(lexicalGlobalObject, throwScope, IDLDouble::extractValueFromNullable(dictionary.processingDuration));
        RETURN_IF_EXCEPTION(throwScope, { });
        result->putDirect(vm, JSC::Identifier::fromString(vm, "processingDuration"_s), processingDurationValue);
    }
    if (!IDLDouble::isNullValue(dictionary.receiveTime)) {
        auto receiveTimeValue = toJS<IDLDouble>(lexicalGlobalObject, throwScope, IDLDouble::extractValueFromNullable(dictionary.receiveTime));
        RETURN_IF_EXCEPTION(throwScope, { });
        result->putDirect(vm, JSC::Identifier::fromString(vm, "receiveTime"_s), receiveTimeValue);
    }
    if (!IDLUnsignedLong::isNullValue(dictionary.rtpTimestamp)) {
        auto rtpTimestampValue = toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, IDLUnsignedLong::extractValueFromNullable(dictionary.rtpTimestamp));
        RETURN_IF_EXCEPTION(throwScope, { });
        result->putDirect(vm, JSC::Identifier::fromString(vm, "rtpTimestamp"_s), rtpTimestampValue);
    }
    auto widthValue = toJS<IDLUnsignedLong>(lexicalGlobalObject, throwScope, dictionary.width);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "width"_s), widthValue);
    return result;
}

#endif

} // namespace WebCore

#endif // ENABLE(VIDEO)
