/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSDetectedText.h"

#include "JSDOMConvertInterface.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMRectReadOnly.h"
#include "JSPoint2D.h"
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

template<> ConversionResult<IDLDictionary<DetectedText>> convertDictionary<DetectedText>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    DetectedText result;
    JSValue boundingBoxValue;
    if (isNullOrUndefined)
        boundingBoxValue = jsUndefined();
    else {
        boundingBoxValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "boundingBox"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (boundingBoxValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "boundingBox"_s, "DetectedText"_s, "DOMRectReadOnly"_s);
        return ConversionResultException { };
    }
    auto boundingBoxConversionResult = convert<IDLInterface<DOMRectReadOnly>>(lexicalGlobalObject, boundingBoxValue);
    if (UNLIKELY(boundingBoxConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.boundingBox = boundingBoxConversionResult.releaseReturnValue();
    JSValue cornerPointsValue;
    if (isNullOrUndefined)
        cornerPointsValue = jsUndefined();
    else {
        cornerPointsValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "cornerPoints"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (cornerPointsValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "cornerPoints"_s, "DetectedText"_s, "FrozenArray"_s);
        return ConversionResultException { };
    }
    auto cornerPointsConversionResult = convert<IDLFrozenArray<IDLDictionary<Point2D>>>(lexicalGlobalObject, cornerPointsValue);
    if (UNLIKELY(cornerPointsConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.cornerPoints = cornerPointsConversionResult.releaseReturnValue();
    JSValue rawValueValue;
    if (isNullOrUndefined)
        rawValueValue = jsUndefined();
    else {
        rawValueValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "rawValue"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (rawValueValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "rawValue"_s, "DetectedText"_s, "DOMString"_s);
        return ConversionResultException { };
    }
    auto rawValueConversionResult = convert<IDLDOMString>(lexicalGlobalObject, rawValueValue);
    if (UNLIKELY(rawValueConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.rawValue = rawValueConversionResult.releaseReturnValue();
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::JSGlobalObject& lexicalGlobalObject, JSDOMGlobalObject& globalObject, const DetectedText& dictionary)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);

    auto result = constructEmptyObject(&lexicalGlobalObject, globalObject.objectPrototype());

    auto boundingBoxValue = toJS<IDLInterface<DOMRectReadOnly>>(lexicalGlobalObject, globalObject, throwScope, dictionary.boundingBox);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "boundingBox"_s), boundingBoxValue);
    auto cornerPointsValue = toJS<IDLFrozenArray<IDLDictionary<Point2D>>>(lexicalGlobalObject, globalObject, throwScope, dictionary.cornerPoints);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "cornerPoints"_s), cornerPointsValue);
    auto rawValueValue = toJS<IDLDOMString>(lexicalGlobalObject, throwScope, dictionary.rawValue);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "rawValue"_s), rawValueValue);
    return result;
}

} // namespace WebCore
