/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSMediaCapabilitiesEncodingInfo.h"

#include "JSDOMConvertBoolean.h"
#include "JSDOMGlobalObject.h"
#include "JSMediaEncodingConfiguration.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

template<> ConversionResult<IDLDictionary<MediaCapabilitiesEncodingInfo>> convertDictionary<MediaCapabilitiesEncodingInfo>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    MediaCapabilitiesEncodingInfo result;
    JSValue powerEfficientValue;
    if (isNullOrUndefined)
        powerEfficientValue = jsUndefined();
    else {
        powerEfficientValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "powerEfficient"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (powerEfficientValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "powerEfficient"_s, "MediaCapabilitiesEncodingInfo"_s, "boolean"_s);
        return ConversionResultException { };
    }
    auto powerEfficientConversionResult = convert<IDLBoolean>(lexicalGlobalObject, powerEfficientValue);
    if (UNLIKELY(powerEfficientConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.powerEfficient = powerEfficientConversionResult.releaseReturnValue();
    JSValue smoothValue;
    if (isNullOrUndefined)
        smoothValue = jsUndefined();
    else {
        smoothValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "smooth"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (smoothValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "smooth"_s, "MediaCapabilitiesEncodingInfo"_s, "boolean"_s);
        return ConversionResultException { };
    }
    auto smoothConversionResult = convert<IDLBoolean>(lexicalGlobalObject, smoothValue);
    if (UNLIKELY(smoothConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.smooth = smoothConversionResult.releaseReturnValue();
    JSValue supportedValue;
    if (isNullOrUndefined)
        supportedValue = jsUndefined();
    else {
        supportedValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "supported"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (supportedValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "supported"_s, "MediaCapabilitiesEncodingInfo"_s, "boolean"_s);
        return ConversionResultException { };
    }
    auto supportedConversionResult = convert<IDLBoolean>(lexicalGlobalObject, supportedValue);
    if (UNLIKELY(supportedConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.supported = supportedConversionResult.releaseReturnValue();
    if (jsCast<JSDOMGlobalObject*>(&lexicalGlobalObject)->scriptExecutionContext()->settingsValues().mediaCapabilitiesExtensionsEnabled) {
        JSValue supportedConfigurationValue;
        if (isNullOrUndefined)
            supportedConfigurationValue = jsUndefined();
        else {
            supportedConfigurationValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "supportedConfiguration"_s));
            RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
        }
        if (!supportedConfigurationValue.isUndefined()) {
            auto supportedConfigurationConversionResult = convert<IDLDictionary<MediaEncodingConfiguration>>(lexicalGlobalObject, supportedConfigurationValue);
            if (UNLIKELY(supportedConfigurationConversionResult.hasException(throwScope)))
                return ConversionResultException { };
            result.supportedConfiguration = supportedConfigurationConversionResult.releaseReturnValue();
        }
    }
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::JSGlobalObject& lexicalGlobalObject, JSDOMGlobalObject& globalObject, const MediaCapabilitiesEncodingInfo& dictionary)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);

    auto result = constructEmptyObject(&lexicalGlobalObject, globalObject.objectPrototype());

    auto powerEfficientValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.powerEfficient);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "powerEfficient"_s), powerEfficientValue);
    auto smoothValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.smooth);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "smooth"_s), smoothValue);
    auto supportedValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.supported);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "supported"_s), supportedValue);
    if (jsCast<JSDOMGlobalObject*>(&globalObject)->scriptExecutionContext()->settingsValues().mediaCapabilitiesExtensionsEnabled) {
        if (!IDLDictionary<MediaEncodingConfiguration>::isNullValue(dictionary.supportedConfiguration)) {
            auto supportedConfigurationValue = toJS<IDLDictionary<MediaEncodingConfiguration>>(lexicalGlobalObject, globalObject, throwScope, IDLDictionary<MediaEncodingConfiguration>::extractValueFromNullable(dictionary.supportedConfiguration));
            RETURN_IF_EXCEPTION(throwScope, { });
            result->putDirect(vm, JSC::Identifier::fromString(vm, "supportedConfiguration"_s), supportedConfigurationValue);
        }
    }
    return result;
}

} // namespace WebCore
