/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSNavigationPreloadState.h"

#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertOptional.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMGlobalObject.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

template<> ConversionResult<IDLDictionary<NavigationPreloadState>> convertDictionary<NavigationPreloadState>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    NavigationPreloadState result;
    JSValue enabledValue;
    if (isNullOrUndefined)
        enabledValue = jsUndefined();
    else {
        enabledValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "enabled"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto enabledConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, enabledValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { false }; });
    if (UNLIKELY(enabledConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.enabled = enabledConversionResult.releaseReturnValue();
    JSValue headerValueValue;
    if (isNullOrUndefined)
        headerValueValue = jsUndefined();
    else {
        headerValueValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "headerValue"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (!headerValueValue.isUndefined()) {
        auto headerValueConversionResult = convert<IDLByteString>(lexicalGlobalObject, headerValueValue);
        if (UNLIKELY(headerValueConversionResult.hasException(throwScope)))
            return ConversionResultException { };
        result.headerValue = headerValueConversionResult.releaseReturnValue();
    }
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::JSGlobalObject& lexicalGlobalObject, JSDOMGlobalObject& globalObject, const NavigationPreloadState& dictionary)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);

    auto result = constructEmptyObject(&lexicalGlobalObject, globalObject.objectPrototype());

    auto enabledValue = toJS<IDLBoolean>(lexicalGlobalObject, throwScope, dictionary.enabled);
    RETURN_IF_EXCEPTION(throwScope, { });
    result->putDirect(vm, JSC::Identifier::fromString(vm, "enabled"_s), enabledValue);
    if (!IDLByteString::isNullValue(dictionary.headerValue)) {
        auto headerValueValue = toJS<IDLByteString>(lexicalGlobalObject, throwScope, IDLByteString::extractValueFromNullable(dictionary.headerValue));
        RETURN_IF_EXCEPTION(throwScope, { });
        result->putDirect(vm, JSC::Identifier::fromString(vm, "headerValue"_s), headerValueValue);
    }
    return result;
}

} // namespace WebCore
